'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = featureLoader;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reduxFeatures = require('redux-features');

var _reselect = require('reselect');

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelPluginFlowReactPropTypes_proptype_FeatureStates = require('redux-features').babelPluginFlowReactPropTypes_proptype_FeatureStates || require('react').PropTypes.any;

var babelPluginFlowReactPropTypes_proptype_FeatureState = require('redux-features').babelPluginFlowReactPropTypes_proptype_FeatureState || require('react').PropTypes.any;

Object.defineProperty(module.exports, 'babelPluginFlowReactPropTypes_proptype_Options', {
  value: require('react').PropTypes.shape({
    getFeatures: require('react').PropTypes.func,
    getFeatureStates: require('react').PropTypes.func,
    featureId: require('react').PropTypes.string.isRequired,
    render: require('react').PropTypes.func
  })
});
function featureLoader(options) {
  var _defaults = (0, _lodash2.default)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : undefined;
    },
    getFeatureStates: function getFeatureStates(state) {
      return state ? state.featureStates : undefined;
    }
  }),
      getFeatures = _defaults.getFeatures,
      getFeatureStates = _defaults.getFeatureStates,
      featureId = _defaults.featureId,
      render = _defaults.render;

  var select = (0, _reselect.createSelector)(getFeatures, getFeatureStates, function () {
    var features = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var featureStates = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return {
      feature: features[featureId],
      featureState: featureStates[featureId]
    };
  });

  var FeatureLoader = function (_Component) {
    (0, _inherits3.default)(FeatureLoader, _Component);

    function FeatureLoader() {
      (0, _classCallCheck3.default)(this, FeatureLoader);
      return (0, _possibleConstructorReturn3.default)(this, (FeatureLoader.__proto__ || (0, _getPrototypeOf2.default)(FeatureLoader)).apply(this, arguments));
    }

    (0, _createClass3.default)(FeatureLoader, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _props = this.props,
            featureState = _props.featureState,
            dispatch = _props.dispatch;

        if (featureState === 'NOT_LOADED') dispatch((0, _reduxFeatures.loadFeature)(featureId));
      }
    }, {
      key: 'render',
      value: function (_render) {
        function render() {
          return _render.apply(this, arguments);
        }

        render.toString = function () {
          return _render.toString();
        };

        return render;
      }(function () {
        var _props2 = this.props,
            featureState = _props2.featureState,
            feature = _props2.feature,
            featureComponentProps = _props2.featureComponentProps;

        return render ? render({ featureState: featureState, feature: feature, props: featureComponentProps }) : null;
      })
    }]);
    return FeatureLoader;
  }(_react.Component);

  var Wrapped = (0, _reactRedux.connect)(select)(FeatureLoader);

  var FeatureComponentProxy = function FeatureComponentProxy(props) {
    return _react2.default.createElement(Wrapped, { featureComponentProps: props });
  };
  return FeatureComponentProxy;
}
featureLoader.propTypes = {
  getFeatures: require('react').PropTypes.func,
  getFeatureStates: require('react').PropTypes.func,
  featureId: require('react').PropTypes.string.isRequired,
  render: require('react').PropTypes.func
};